<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * CashU Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2013 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Nov 2012
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentCashuForVirtuemart extends vmPSPlugin {

	public static $_this = false;
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);

		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    
    $ok_request=isset($_GET['cashuok'])?1:0;
    $fail_request=isset($_GET['cashusorry'])?1:0;
    
    if($ok_request || $fail_request)
    {
      $this->plgVmOnPaymentNotification();
    }
    
    
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment CashU Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
	    'id' => ' INT(11) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' => ' int(1) UNSIGNED DEFAULT NULL',
	    'order_number' => ' char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' => ' mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' => 'varchar(5000)',
	    'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' => 'char(3) ',
	    'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
	    'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
	    'tax_id' => ' smallint(1) DEFAULT NULL'
		);
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=cashuforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'cashulic'=>$lic),'cashuforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your CashU - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('cashulic'=>'','dchk'=>''),'cashuforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    
    $params1  = $this->getParams('cashuforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['cashulic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your CashU - Payment Gateway License Code', 'error');
        $this->setParams(array('cashulic'=>'','dchk'=>''),'cashuforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          if($chk!=$dchk)//check
          {
            $this->setParams(array('cashulic'=>'','dchk'=>''),'cashuforvirtuemart');
            $application->enqueueMessage('Provided License code is wrong', 'error');
            return;
          }
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->user)) {
			vmInfo(JText::_('CashU Merchant ID Missing!!!'));
			return false;
		}
		if (empty($method->password)) {
			vmInfo(JText::_('CashU Encryption Key Missing!!!'));
			return false;
		}

    $CashU_button='Click here to Pay';

    $test_mode=0;
    $MerchantId = $method->user;
    if($method->test=='TEST')
	  {
	    $test_mode=1;
	  }

    $Amount = round($order['details']['BT']->order_total,2);
    $currency = $currency_code_3;
    $keyword = $method->password;
    $token=md5(strtolower($MerchantId). ":" .$Amount. ":" .strtolower($currency). ":" .$keyword);
    
    $langs_arr=array('IR','EN','AR');
    $lang = JFactory::getLanguage(); 
    $languages = JLanguageHelper::getLanguages('lang_code'); 
    $languageCode = $languages[ $lang->getTag() ]->sef; 
    $languageCode=strtoupper($languageCode);
    if(!in_array($languageCode,$langs_arr))
    {
      $languageCode='EN';
    }
    $languageCode=strtolower($languageCode);
    
    $post_variables=array(
    'merchant_id'=>$MerchantId,
    'token'=>$token,
    'session_id'=>$order['details']['BT']->order_number,
    'test_mode'=>$test_mode,
    'display_text'=>'Your '.$_SERVER['HTTP_HOST'].' order.',
    'language'=>$languageCode,
    'txt1'=>'Order '.$order['details']['BT']->order_number,
    'amount'=>$Amount,
    'currency'=>$currency,
    'billing_cust_name'=>$usrBT->first_name,
  	'billing_last_name'=>$usrBT->last_name,
  	'billing_cust_address'=>$usrBT->address_1.' '.$usrBT->address_2,
  	'billing_cust_city'=>$usrBT->city,
  	'billing_cust_state'=>isset($usrBT->virtuemart_state_id) ? ShopFunctions::getStateByID($usrBT->virtuemart_state_id,'state_name') : '',
  	'billing_cust_country'=>ShopFunctions::getCountryByID($usrBT->virtuemart_country_id,'country_2_code'),
  	'billing_cust_zip'=>$usrBT->zip,
  	'billing_cust_tel_No'=>$usrBT->phone_1,
  	'billing_cust_email'=>$usrBT->email,
  	'delivery_cust_name'=>$usrST->first_name,
  	'delivery_last_name'=>$usrST->last_name,
  	'delivery_cust_address'=>$usrST->address_1.' '.$usrST->address_2,
  	'delivery_cust_city'=>$usrST->city,
  	'delivery_cust_state'=>isset($usrST->virtuemart_state_id) ? ShopFunctions::getStateByID($usrST->virtuemart_state_id,'state_name') : '',
  	'delivery_cust_country'=>ShopFunctions::getCountryByID($usrST->virtuemart_country_id,'country_2_code'),
  	'delivery_cust_zip'=>$usrST->zip,
  	'delivery_cust_tel_No'=>$usrST->phone_1
    );
    
  	
		$html = '<div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="CashUfrm" id="CashUfrm" action="https://www.cashu.com/cgi-bin/pcashu.cgi" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$CashU_button.'" />';
		$html.= '</form></div>';
		//$html.=htmlentities($strPost);
		$html.= ' <script type="text/javascript">';
		$html.= ' document.CashUfrm.submit();';
		$html.= ' </script>';
		
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		return true;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	  if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
    $data=$_GET;
		$trn_id=@$data['trn_id'];
    $verificationString=@$data['verificationString'];
    $verificationString1=sha1($method->user.':'.$trn_id.':'.$method->password);
    if($verificationString==$verificationString1)
    {
      $order_paid = 1;
    }
		$modelOrder = VmModel::getModel('orders');
		$order = array();

		$order['customer_notified'] = 1;

		if ($order_paid == 1) {
			$order['order_status'] = $method->status_success;
		}
    else
    {
      $order['order_status'] = $method->status_canceled;
    }

		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, FALSE);
    
    $db = &JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
    if ($order_paid == 1)
    {
      $cart = VirtueMartCart::getCart();
		  $cart->emptyCart();
			$app=JFactory::getApplication();
      $app->enqueueMessage('Thank you for your order.');
      $app->redirect(JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$order_number.'&order_pass='.$result->order_pass);
      exit;
		}
    else
    {
      $app=JFactory::getApplication();
      $app->enqueueMessage('Please note that your order was Cancelled.','error');
      $app->redirect(JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$order_number.'&order_pass='.$result->order_pass);
      exit;
    }
		
		return TRUE;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getCashuInternalData($virtuemart_order_id, $order_number='') {
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $paymentTable;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
    $html='';
		return $html;
	}

	function plgVmOnPaymentNotification() {

    if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		$data = JRequest::get('post');
		if (!isset($data['session_id'])) {
			return FALSE;
		}

		$order_number = $data['session_id'];
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return FALSE;
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return FALSE;
		}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
    $pm=$payments[0]->virtuemart_paymentmethod_id;
		$trn_id=@$data['trn_id'];
    $verificationString=@$data['verificationString'];
    $redirect_url=JURI::base().'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&trn_id='.$trn_id.'&verificationString='.$verificationString.'&on='.$order_number.'&pm='.$pm;
    echo '
    <script type="text/javascript">
    window.location="'.$redirect_url.'";
    </script>
    ';
    exit;
	}

	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {

		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
		return true;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}
}

// No closing tag
